/* 
 * File:   Console.cpp
 * Author: Belhadj&&Jardak
 * 
 * Created on June 17, 2010, 12:06 AM
 */

#include "Console.h"
#include <iostream>
#include <sstream>


Console::Console() {
    commande="";
    ch1="";
    ch2="";
    ch3="";
}

Console::~Console() {
}
///supprime la redondance des espaces
void Console::norme()
{
    int i=0;
    if (commande[commande.size()-1]==' ')
    {
       commande=commande.substr(0,commande.size()-1);
       norme();
    }
    else
    {
        if(commande[0]==' ')
        {
            commande=commande.substr(1,commande.size()-1);
            norme();
        }
        else
        {
            while(commande[i]!='\0')
            {
                while((commande[i]!=' ')&&(commande[i]!='\0'))
                {
                    i=i+1;
                }
                i=i+1;
                if(commande[i]==' ')
                {
                    commande=commande.substr(0,(i))+commande.substr(i+1);
                    norme();
                }
                else
                {
                    if(commande[i]!='\0')
                    {
                        i=i+1;
                    }
                }
            }
        }
    }
}


//ch1 ch2 ch3 les trois chines contenant les argument de la commande;
//return 0 la chaine est vide
//return 1 1arguments
//return 2 2arguments
//return 3 3arguments
//return 4 la chaine contient plus que 4 argument
//return 5 l'utilisteur veut quitter le programme

int Console::get_commande()
{
    string temp1="",temp2="",temp3="";
    int i=0;

    cout<<">>";
    getline(cin,commande);
    norme();
    while((commande=="q")||(commande=="Q"))
    {
        do
        {
            cout<<"Etes vous sure de quitter le programme (y,n)";
            getline(cin,commande);
            norme();
        }while((commande!="y")&&(commande!="n"));
        if(commande=="y")
        {
            cout<<"Bye!!"<<endl;
            return 5;
        }
        else
        {
            cout<<">>";
            getline(cin,commande);
            norme();
        }
    }
    if(commande=="")
    {
        return 0;
    }
    else
    {
        while((commande[i]!=' ')&&(commande[i]!='\0'))
        {
            temp1=temp1+commande[i];
            i=i+1;
        }
        if(commande[i]!='\0')
        {
            i=i+1;
        }
        else
        {
            ch1=temp1;
            ch2=temp2;
            ch3=temp3;
            return 1;
        }
        while((commande[i]!=' ')&&(commande[i]!='\0'))
        {
            temp2=temp2+commande[i];
            i=i+1;
        }
        if(commande[i]!='\0')
        {
            i=i+1;
        }
        else
        {
            ch1=temp1;
            ch2=temp2;
            ch3=temp3;
            return 2;
        }
        while((commande[i]!=' ')&&(commande[i]!='\0'))
        {
            temp3=temp3+commande[i];
            i=i+1;
        }
        if(commande[i]!='\0')
        {
            return 4;
        }
        else
        {
            ch1=temp1;
            ch2=temp2;
            ch3=temp3;
            return 3;

        }
    }
}


//verifie si une chaine estbien sous la forme de [l,c]
//+moins de boucle
//+bug_fixed: on ne peut plus ecrire "edit [$4,3] 5"
bool Console::verif_cel(int f)
{
    int i=1,a=0,k=0;
    string ch;
    if (f==1)
        ch=ch1;
    else if(f==2)
        ch=ch2;
    else if(f==3)
        ch=ch3;
    while(i<(ch.length()-1))
    {
        a=ch[i];   //l'ascii du caractere
        if(((a>47)&&(a<58))||(a==44))
        {
            i=i+1;
            if (a==44)
                k++;
        }
        else
        {
            return false;
        }
    }
    if((ch[0]=='[')&&(ch[(ch.size()-1)]==']')&&(ch[1]!=',')&&(ch[ch.size()-2]!=',')&&(k==1))
    {
        //pas la peine de verifier si les entiers l et c sont positive ou non puisque
        //l'utilisateur ne peut entrer que des chiffres et une virgule entre deux crochets
        //cepandant il faut verifier est ce que les deu entien sont differents de 0
        int l,c;
        cel_int(f,l,c);
        if((l!=0)&&(c!=0))
            return true;
        else
            throw "~~Error: L'entree Cellule n'est pas dans les normes: [l>0,c>0] ";
    }
    else
    {
        return false;
    }

}


//change "[l,c]" en l et c
void Console::cel_int(int f,int& l,int& c)
{
    string L,C;
    int k=1;
    string ch;
    if (f==1)
        ch=ch1;
    else if(f==2)
        ch=ch2;
    else if(f==3)
        ch=ch3;
    while(ch[k]!=',')
    {
        L=L+ch[k];
        k=k+1;
    }
    istringstream s1(L);
    s1>>l;
    k=k+1;
    while(ch[k]!=']')
    {
        C=C+ch[k];
        k=k+1;
    }
    istringstream s2(C);
    s2>>c;
}


//la methode qui traite la commande
void Console::traitement()
{
    int a=0;
    Tableur T;
        while(1)
        {
            try{
            a=get_commande();
            if (a==1)
            {
                if(ch1=="eval")
                {
                    int l,c;
                    if (l==0||c==0)
                    {
                        throw "~~Error: Cellule active non definie";
                    }
                    else
                    T.get_active(l,c);
                    cout<<"Le resultat de la cellule active "<<"["<<l<<","<<c<<"]"<<" est "<<T.eval(l,c)<<endl;
                }
                else if(ch1=="afficheF")
                {
                    T.afficheF();
                }
                else if(ch1=="afficheC")
                {
                    T.afficheC();
                }
                else if(ch1=="help")
                {
                    cout<<"help menu :"<<endl;
                    cout<<"les commandes possibles sont:"<<endl;
                    cout<<"     afficheF                 Afficher le tableur avec ces formules"<<endl;
                    cout<<"     afficheC                 Afficher le tableur avec ces contenues"<<endl;
                    cout<<"     active [l,c]            Rendre la cellule [l,c] active"<<endl;
                    cout<<"     edit [l,c] formule      Editer la formule de la cellule [l,c]"<<endl;
                    cout<<"     edite formule           Editer la formule de la cellule active"<<endl;
                    cout<<"     copy [ls,cs] [ld,cd]    Copier la formule de cellule [ls,cs] dans la cellule [ld,cd]"<<endl;
                    cout<<"     copy [ld,cd]            Copier la forule de la cellule active dans la cellule [ld,cd]"<<endl;
                    cout<<"     eval [l,c]              Evaluer la formule de la cellule [l,c]"<<endl;
                    cout<<"     eval                    Evaluer la formule de la cellule active"<<endl;
                    cout<<"	q			Quitter"<<endl;
                }
                else
                {
                    throw "~~Error: Commande not found -- Try help";
                }
            }
            if (a==2)
            {
                if((ch1=="active")||(ch1=="eval")||(ch1=="copy"))
                {
                    if(verif_cel(2))
                    {
                        if(ch1=="active")
                        {
                            int l,c;
                            cel_int(2,l,c);
                            T.active(l,c);
                        }
                        else if(ch1=="eval")
                        {
                            int l,c;
                            cel_int(2,l,c);
                            cout<<"Le resultat de la cellule "<<ch2<<" est "<<T.eval(l,c)<<endl;
                        }
                        else if(ch1=="copy")
                        {
                            int ls,cs,ld,cd;
                            T.get_active(ls,cs);
                            if (ls==0||cs==0)
                            {
                                throw "~~Error: Cellule active non definie";
                            }
                            else
                            cel_int(2,ld,cd);
                            T.copy(ls,cs,ld,cd);
                        }
                        else
                        {
                            throw "~~Error: Commande not found -- Try help";
                        }
                    }
                    else
                    {

                        throw "~~Error: L'entree Cellule n'est pas dans les normes: [l>0,c>0] ";
                    }
                }
                else if(ch1=="edit")
                {
                    int l,c;
                    T.get_active(l,c);
                    if (l==0||c==0)
                    {
                        throw "~~Error: Cellule active non definie";
                    }
                    else
                    T.edit(l,c,ch2);
                }
                else
                {
                    if ((ch1=="afficheC")||(ch1=="afficheF"))
                    {
                        throw "~~Error: Too many arguments -- Try help";
                    }
                    else
                    {
                        throw "~~Error: Commande not found -- Try help";
                    }
                }
            }
            if (a==3)
            {
                if(ch1=="copy")
                {
                    if(verif_cel(2)&&verif_cel(3))
                    {
                        int ls,cs,ld,cd;
                        cel_int(2,ls,cs);
                        cel_int(3,ld,cd);
                        T.copy(ls,cs,ld,cd);
                    }
                    else
                    {
                        throw "~~ Error: L'entree Cellule n'est pas dans les normes: [l>0,c>0] ";
                    }
                }
                else if(ch1=="edit")
                {
                    if(verif_cel(2))
                    {
                        int l,c;
                        cel_int(2,l,c);
                        T.edit(l,c,ch3);
                    }
                    else
                    {
                        throw "~~ Error: L'entree Cellule n'est pas dans les normes: [l>0,c>0] ";
                    }
                }
                else
                {
                    if ((ch1=="afficheF")||(ch1=="afficheC")||(ch1=="eval")||(ch1=="active"))
                    {
                        throw"~~ Error: Too many arguments -- Try help";
                    }
                    else
                    {
                        throw "~~ Error: Commande not found -- Try help";
                    }
                }
            }
            if (a==4)
            {
                throw "~~ Error: Too many arguments -- Try help";
            }
            if (a==5)
            {
                return;
            }
            }
            catch(char const * s)
            {
                cout<<endl<<s<<endl;
            }
        }
}