/* 
 * File:   Tableur.h
 * Author: Belhadj&&Jardak
 *
 * Created on 14 juin 2010, 16:52
 */

#ifndef TABLEUR_H
#define	TABLEUR_H
#include <string>
#include "Cellule.h"

using namespace std;

class Tableur {
    friend class Console;
    
private:

    Tableur();
    Tableur(const Tableur& orig);
    virtual ~Tableur();
    Tableur& operator=(const Tableur &orig);
    void copy(int ls,int cs,int ld,int cd);
    void active(int l,int c);
    void get_active(int& l,int& c)const;
    float mult_div (string ch);
    float add_min(string ch);
    string rechercheF(int l, int c);    
    float eval(int l,int c);
    Cellule * rechercheC(int c, Cellule *& p);
    Cellule * rechercheL(int l, Cellule * cell, Cellule *& p);
    string parenthese(string ch);
    
    
    bool exist(string cel,string ref);
    
    void edit(int l, int c, string formule);
    
    

    void afficheF();
    void afficheC();
    

    
    
    
    
    int rech(string cel,string& ref,int deb=0);
    

private:
    int Lactive;
    int Cactive;
    Cellule * Tete;
};

#endif	/* TABLEUR_H */

